
middrag = {
  onDragStart: function (event, transferData, action)
  { 
    var tabArray=domHelper.tabsElement.childNodes;
    if(event.target.localName != "tab") return;
    var myIndex=-1; 
    for(var i=0; i < tabArray.length; i++)
       if (event.target.id == tabArray[i].id) myIndex=i;
    if (myIndex==-1) return;   
    this.index=myIndex;
    transferData.data = new TransferData();
    transferData.data.addDataForFlavour("text/x-mid-tab", myIndex );
  },

  getSupportedFlavours : function ()
  {
    var flavours = new FlavourSet();
    flavours.appendFlavour("text/x-mid-tab");
    return flavours;
  },
  onDragOver : function(event,flavour,session) {
    return true; 
  },

  onDragEnter :  function(event, session) {
  },

  onDragExit :  function(event, session) {
  },

  canDrop: function(event, session) { 
    if (session.sourceNode &&
        session.sourceNode.parentNode == document.getElementById("mid_tabs") &&
       ((event.screenX >= session.sourceNode.boxObject.screenX &&
       event.screenX <= (session.sourceNode.boxObject.screenX +
        session.sourceNode.boxObject.width)) &&
	   (event.screenY >= session.sourceNode.boxObject.screenY &&
       event.screenY <= (session.sourceNode.boxObject.screenY +
        session.sourceNode.boxObject.height)))
		)
    return false;
    return true;
  },
  
  onDrop: function (event, dropData, session)
  {
    var newIndex=this.getNewIndex(event);
    // if (newIndex > dropData.data) newIndex--;
    if (newIndex != dropData.data) this.moveTabTo(newIndex, session);
  },
  
  moveTabTo: function ( newIndex,session )
  {
    var tabs=domHelper.tabsElement;
    var tabpanels=domHelper.tabpanelsElement;
    var draggedBrowser=tabpanels.getElementsByTagName("browser").item(this.index);
    //session.sourceNode._selected=true;
    //draggedBrowser._selected=true;
    var sh=draggedBrowser.sessionHistory;
    var originalHistory=this.copyTabHistory(sh);
    try {
  	draggedBrowser.removeProgressListener(midWebProgressListener);
    } catch(e) { } 
    //tabs.removeChild(session.sourceNode);
    //tabpanels.removeChild(draggedBrowser);
    tabs.insertBefore(session.sourceNode,tabs.getElementsByTagName("tab").item(newIndex));
    tabpanels.insertBefore(draggedBrowser,tabpanels.getElementsByTagName("browser").item(newIndex));
 
    //for (i = 0; i < tabs.childNodes.length; i++) {
    //  tabs.childNodes[i]._selected = false;
    //  tabpanels.childNodes[i]._selected = false;
    //}
   
    tabs.selectedItem=session.sourceNode;
    tabpanels.selectedPanel=draggedBrowser;
    draggedBrowser.addProgressListener( midWebProgressListener,
		                          Ci.nsIWebProgress.NOTIFY_STATE_NETWORK );
    
    this.restoreDraggedHistory(draggedBrowser.webNavigation, originalHistory );

  },

  getNewIndex: function (event)
  {
    var tabArray=document.getElementById("mid_tabs").getElementsByTagName('tab');
    for(var i=0; i < tabArray.length; i++)
        if(event.clientX < tabArray[i].boxObject.x + tabArray[i].boxObject.width / 2) 
           if(event.clientY < tabArray[i].boxObject.y + tabArray[i].boxObject.height)
              return i;
    return tabArray.length;
  },
 
  copyTabHistory: function(originalHistory)
  {
        var range = {start:0, length:originalHistory.count} ;

	var copiedHistory = new Array();
	for (var i = range.start; i < range.length; i++) {
	copiedHistory.push(originalHistory.getEntryAtIndex(i, false));
	}
	copiedHistory.index = originalHistory.index;

	return copiedHistory;
  },

  restoreDraggedHistory: function(webNav, originalHistory)
  {
    var newHistory = webNav.sessionHistory;

    newHistory.QueryInterface(Components.interfaces.nsISHistoryInternal);

    // delete history entries if they are present
    
    if (newHistory.count > 0)
      newHistory.PurgeHistory(newHistory.count);

    for (var i = 0; i < originalHistory.length; i++) {
      var entry = originalHistory[i].QueryInterface(Components.interfaces.nsISHEntry);
      var newEntry = this.restoreHistoryEntry(entry);
      if (newEntry)
        newHistory.addEntry(newEntry, true);
    }

    // Go to current history location
    if (originalHistory.index < originalHistory.length)
      gotoHistoryIndex(10);

    function gotoHistoryIndex(attempts) {
      try {
        webNav.gotoIndex(originalHistory.index);
      }
      catch(e) {
        // do some math to increase the timeout
        // each time we try to update the history index
        if (attempts)
          setTimeout(gotoHistoryIndex, (11 - attempts) * (15 - attempts), --attempts);
      }
    }
  },

  restoreHistoryEntry: function(aEntry) 
  {
    if (!aEntry)
      return null;
    aEntry = aEntry.QueryInterface(Components.interfaces.nsISHContainer);
    var newEntry = aEntry.clone();
    newEntry = newEntry.QueryInterface(Components.interfaces.nsISHContainer);
    newEntry.loadType = Math.floor(aEntry.loadType);
    if (aEntry.childCount) {
      for (var j = 0; j < aEntry.childCount; j++) {
          var childEntry = this.restoreHistoryEntry(aEntry.GetChildAt(j));
          if (childEntry)
            newEntry.AddChild(childEntry, j);
      }
    }
    return newEntry;
  }
  
};



